<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: pytools/magpar_scripts.py Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_b2edde888cd1578cfb9c7cf94f5f0a3e.html">pytools</a>
  </div>
</div>
<div class="contents">
<h1>magpar_scripts.py</h1><a href="magpar__scripts_8py.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a><a class="code" href="namespacemagpar__scripts.html">00001</a> <span class="comment">#################################</span>
<a name="l00002"></a>00002 <span class="comment">#</span>
<a name="l00003"></a>00003 <span class="comment"># magpar standard Python library</span>
<a name="l00004"></a>00004 <span class="comment">#</span>
<a name="l00005"></a>00005 <span class="comment">#################################</span>
<a name="l00006"></a>00006 
<a name="l00007"></a>00007 <span class="comment"># This file is part of magpar.</span>
<a name="l00008"></a>00008 
<a name="l00009"></a>00009 <span class="comment"># Copyright (C) 2010 Werner Scholz</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment"># www:   http://www.magpar.net/</span>
<a name="l00012"></a>00012 <span class="comment"># email: magpar(at)magpar.net</span>
<a name="l00013"></a>00013 
<a name="l00014"></a>00014 <span class="comment"># magpar is free software; you can redistribute it and/or modify</span>
<a name="l00015"></a>00015 <span class="comment"># it under the terms of the GNU General Public License as published by</span>
<a name="l00016"></a>00016 <span class="comment"># the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00017"></a>00017 <span class="comment"># (at your option) any later version.</span>
<a name="l00018"></a>00018 
<a name="l00019"></a>00019 <span class="comment"># magpar is distributed in the hope that it will be useful,</span>
<a name="l00020"></a>00020 <span class="comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00021"></a>00021 <span class="comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00022"></a>00022 <span class="comment"># GNU General Public License for more details.</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment"># You should have received a copy of the GNU General Public License</span>
<a name="l00025"></a>00025 <span class="comment"># along with magpar; if not, write to the Free Software</span>
<a name="l00026"></a>00026 <span class="comment"># Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">import</span> math, random, unittest, cProfile
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment"># Vector class inspired by</span>
<a name="l00031"></a>00031 <span class="comment"># http://www.gamedev.net/community/forums/topic.asp?topic_id=486122</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment"># see also:</span>
<a name="l00034"></a>00034 <span class="comment">#http://code.activestate.com/recipes/52272/</span>
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="classmagpar__scripts_1_1Vector.html">00036</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1Vector.html">Vector</a>(object):
<a name="l00037"></a>00037     <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00038"></a>00038 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00039"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a15bcda734560782fb916b4432aec3a03">00039</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a15bcda734560782fb916b4432aec3a03">__init__</a>(self, p = [0, 0, 0]):
<a name="l00040"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">00040</a>         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> = float(p[0])
<a name="l00041"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">00041</a>         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> = float(p[1])
<a name="l00042"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">00042</a>         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> = float(p[2])
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#ab9e4ddd248e94e963f8ff3a6dc12e973">00044</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#ab9e4ddd248e94e963f8ff3a6dc12e973">__getitem__</a>(self, key):
<a name="l00045"></a>00045         <span class="keywordflow">if</span>(key == 0):
<a name="l00046"></a>00046             <span class="keywordflow">return</span> self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>
<a name="l00047"></a>00047         <span class="keywordflow">elif</span>(key == 1):
<a name="l00048"></a>00048             <span class="keywordflow">return</span> self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>
<a name="l00049"></a>00049         <span class="keywordflow">elif</span>(key == 2):
<a name="l00050"></a>00050             <span class="keywordflow">return</span> self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>
<a name="l00051"></a>00051         <span class="keywordflow">else</span>:
<a name="l00052"></a>00052             <span class="keywordflow">raise</span> Exception(<span class="stringliteral">&quot;Invalid key to Vector&quot;</span>)
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#abf8c5f1a26eceb4cca9995b4913f1676">00054</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#abf8c5f1a26eceb4cca9995b4913f1676">__setitem__</a>(self, key, value):
<a name="l00055"></a>00055         <span class="keywordflow">if</span>(key == 0):
<a name="l00056"></a>00056             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> = value
<a name="l00057"></a>00057         <span class="keywordflow">elif</span>(key == 1):
<a name="l00058"></a>00058             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> = value
<a name="l00059"></a>00059         <span class="keywordflow">elif</span>(key == 2):
<a name="l00060"></a>00060             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> = value
<a name="l00061"></a>00061         <span class="keywordflow">else</span>:
<a name="l00062"></a>00062             <span class="keywordflow">raise</span> Exception(<span class="stringliteral">&quot;Invalid key to Vector&quot;</span>)
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a21c1acef8d413b1a455c8f952675dabc">00064</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a21c1acef8d413b1a455c8f952675dabc">copy</a>(self):
<a name="l00065"></a>00065         <span class="keywordflow">return</span> Vector([self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>,self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>,self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>])
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a5528773ef394ef34766cbb1b182f7a22">00067</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a5528773ef394ef34766cbb1b182f7a22">__neg__</a>(self):
<a name="l00068"></a>00068         <span class="keywordflow">return</span> Vector([-self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>,-self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>,-self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>])
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a3e1e299099628d2f607abf697ebda8cc">00070</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a3e1e299099628d2f607abf697ebda8cc">__abs__</a>(self):
<a name="l00071"></a>00071         <span class="keywordflow">return</span> math.sqrt(self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>*self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>+self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>*self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>+self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>*self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>)
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a0cd76f25e9f55bbaadee54c1c69756f2">00073</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a0cd76f25e9f55bbaadee54c1c69756f2">__pow__</a>(self, val):
<a name="l00074"></a>00074         <span class="keywordflow">return</span> abs(self)**val
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#aa04061bb54a7327f533c4774f7401394">00076</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#aa04061bb54a7327f533c4774f7401394">__add__</a>(self, val):
<a name="l00077"></a>00077         <span class="keywordflow">return</span> Vector([self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> + val.x, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> + val.y, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> + val.z])
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#ac1a463ee68e950a2cf6c21a2a52db84e">00079</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#ac1a463ee68e950a2cf6c21a2a52db84e">__iadd__</a>(self, val):
<a name="l00080"></a>00080         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> += val.x
<a name="l00081"></a>00081         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> += val.y
<a name="l00082"></a>00082         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> += val.z
<a name="l00083"></a>00083         <span class="keywordflow">return</span> self
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a4dca7e09cb8a376622c7fa483b76d0e2">00085</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a4dca7e09cb8a376622c7fa483b76d0e2">__sub__</a>(self,val):
<a name="l00086"></a>00086         <span class="keywordflow">return</span> Vector([self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> - val.x, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> - val.y, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> - val.z])
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a2d6e68f8bcf0803243084877494a4cf5">00088</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a2d6e68f8bcf0803243084877494a4cf5">__isub__</a>(self, val):
<a name="l00089"></a>00089         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> -= val.x
<a name="l00090"></a>00090         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> -= val.y
<a name="l00091"></a>00091         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> -= val.z
<a name="l00092"></a>00092         <span class="keywordflow">return</span> self
<a name="l00093"></a>00093 
<a name="l00094"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a3b7855ba9ccb9339bb444985d6801e22">00094</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a3b7855ba9ccb9339bb444985d6801e22">__mul__</a>(self, val):
<a name="l00095"></a>00095         <span class="keywordflow">if</span> type(val) == Vector:
<a name="l00096"></a>00096           <span class="keywordflow">return</span> self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> * val.x + self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> * val.y + self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> * val.z
<a name="l00097"></a>00097         <span class="keywordflow">else</span>:
<a name="l00098"></a>00098           <span class="keywordflow">return</span> Vector([self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> * val, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> * val, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> * val])
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a052f01f46c82e5e5be189a9df2e19605">00100</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a052f01f46c82e5e5be189a9df2e19605">__rmul__</a>(self, val):
<a name="l00101"></a>00101         <span class="keywordflow">if</span> type(val) == Vector:
<a name="l00102"></a>00102           <span class="keywordflow">return</span> self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> * val.x + self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> * val.y + self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> * val.z
<a name="l00103"></a>00103         <span class="keywordflow">else</span>:
<a name="l00104"></a>00104           <span class="keywordflow">return</span> Vector([self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> * val, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> * val, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> * val])
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#aec81b8cfceaa379982de1608b816e3c9">00106</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#aec81b8cfceaa379982de1608b816e3c9">__imul__</a>(self, val):
<a name="l00107"></a>00107         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> *= val
<a name="l00108"></a>00108         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> *= val
<a name="l00109"></a>00109         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> *= val
<a name="l00110"></a>00110         <span class="keywordflow">return</span> self
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a839fa607a21050767bb9209eb325c67b">00112</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a839fa607a21050767bb9209eb325c67b">__div__</a>(self, val):
<a name="l00113"></a>00113         <span class="keywordflow">return</span> Vector([self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> / val, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> / val, self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> / val])
<a name="l00114"></a>00114 
<a name="l00115"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#aa7979f89e47b5ac3487993e809a6e23a">00115</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#aa7979f89e47b5ac3487993e809a6e23a">__idiv__</a>(self, val):
<a name="l00116"></a>00116         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> /= val
<a name="l00117"></a>00117         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> /= val
<a name="l00118"></a>00118         self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> /= val
<a name="l00119"></a>00119         <span class="keywordflow">return</span> self
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#ae8427b27748b7a7767fbd2ae25286574">00121</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#ae8427b27748b7a7767fbd2ae25286574">outer</a>(self,b):
<a name="l00122"></a>00122         <span class="keywordflow">return</span> Vector([self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>*b.z-self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>*b.y,
<a name="l00123"></a>00123                        self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>*b.x-self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>*b.z,
<a name="l00124"></a>00124                        self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>*b.y-self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>*b.x])
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a09df02a39b73d9b4222195986f5bbcfd">00126</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a09df02a39b73d9b4222195986f5bbcfd">normalize</a>(self):
<a name="l00127"></a>00127         <span class="keywordflow">if</span> abs(self)&lt;1e-9:
<a name="l00128"></a>00128             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> = 0.0
<a name="l00129"></a>00129             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> = 0.0
<a name="l00130"></a>00130             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> = 0.0
<a name="l00131"></a>00131         <span class="keywordflow">else</span>:
<a name="l00132"></a>00132             l = abs(self)
<a name="l00133"></a>00133             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a> /= l
<a name="l00134"></a>00134             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a> /= l
<a name="l00135"></a>00135             self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a> /= l
<a name="l00136"></a>00136         <span class="keywordflow">return</span> self
<a name="l00137"></a>00137 
<a name="l00138"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a4599677d71ef111ab30b5c5b107c422a">00138</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a4599677d71ef111ab30b5c5b107c422a">__eq__</a>(self,other):
<a name="l00139"></a>00139         <span class="keywordflow">if</span> (self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>==other.x) &amp; (self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>==other.y) &amp; (self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>==other.z):
<a name="l00140"></a>00140             <span class="keywordflow">return</span> <span class="keyword">True</span>
<a name="l00141"></a>00141         <span class="keywordflow">else</span>:
<a name="l00142"></a>00142             <span class="keywordflow">return</span> <span class="keyword">False</span>
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#aedd46ba72c65f72f71ef3962f107ea15">00144</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#aedd46ba72c65f72f71ef3962f107ea15">__ne__</a>(self,other):
<a name="l00145"></a>00145         <span class="keywordflow">return</span> <span class="keywordflow">not</span>(self==other)
<a name="l00146"></a>00146 
<a name="l00147"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#a627782f8fdd3439b3dc702226cf40c2c">00147</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#a627782f8fdd3439b3dc702226cf40c2c">__repr__</a>(self):
<a name="l00148"></a>00148         <span class="keywordflow">return</span> <span class="stringliteral">&quot;[&quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>) + <span class="stringliteral">&quot;,&quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>) + <span class="stringliteral">&quot;,&quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>) + <span class="stringliteral">&quot;]&quot;</span>
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="classmagpar__scripts_1_1Vector.html#af4f34cdf6e5561fc5b79a1095e0b1844">00150</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Vector.html#af4f34cdf6e5561fc5b79a1095e0b1844">__str__</a>(self):
<a name="l00151"></a>00151         <span class="keywordflow">return</span> <span class="stringliteral">&quot;(&quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Vector.html#a36ae38a8ddc7507c0a257b1406a5976e">x</a>) + <span class="stringliteral">&quot;,&quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Vector.html#aeffa4eccf42c128e42249910abc447bb">y</a>) + <span class="stringliteral">&quot;,&quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Vector.html#ae850a468f4f71dfdaf19083822b4bf24">z</a>) + <span class="stringliteral">&quot;)&quot;</span>
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html">00153</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html">TestVectorClass</a>(unittest.TestCase):
<a name="l00154"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a217fc0c725b08fdb8b8ac5ee20308fa2">00154</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a217fc0c725b08fdb8b8ac5ee20308fa2">setUp</a>(self):
<a name="l00155"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">00155</a>         self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a>=Vector([1,0,0])
<a name="l00156"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a765656d62f787a28edb0ebfe8d99d8ff">00156</a>         self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a765656d62f787a28edb0ebfe8d99d8ff">y</a>=Vector([0,1,0])
<a name="l00157"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#afffaaaf95e78ae1659732957885268a4">00157</a>         self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#afffaaaf95e78ae1659732957885268a4">z</a>=Vector([0,0,1])
<a name="l00158"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">00158</a>         self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a>=Vector([3,0,0])
<a name="l00159"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a6b5e0f626398d535781ca77d9a21d571">00159</a>         self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a6b5e0f626398d535781ca77d9a21d571">b</a>=Vector([0,4,0])
<a name="l00160"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#aac73afdc7768f9a884c55c7d1c5559f1">00160</a>         self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#aac73afdc7768f9a884c55c7d1c5559f1">c</a>=Vector([3,4,0])
<a name="l00161"></a>00161 
<a name="l00162"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a117d4fa22da3509bfb8205320d241921">00162</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a117d4fa22da3509bfb8205320d241921">testNeg</a>(self):
<a name="l00163"></a>00163         t = self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#aac73afdc7768f9a884c55c7d1c5559f1">c</a>.copy()
<a name="l00164"></a>00164         t = -t
<a name="l00165"></a>00165         self.assertEqual(t,Vector([-3,-4,0]))
<a name="l00166"></a>00166 
<a name="l00167"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ac47043842b47255a7705a71558fafd17">00167</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ac47043842b47255a7705a71558fafd17">testAbs</a>(self):
<a name="l00168"></a>00168         t=abs(self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a>)
<a name="l00169"></a>00169         self.assertEqual(t,3.0)
<a name="l00170"></a>00170         t=abs(self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#aac73afdc7768f9a884c55c7d1c5559f1">c</a>)
<a name="l00171"></a>00171         self.assertEqual(t,5.0)
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ad351b58d7c717bbb4d61a6ecf6e11e5a">00173</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ad351b58d7c717bbb4d61a6ecf6e11e5a">testPow</a>(self):
<a name="l00174"></a>00174         t=self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a>**2.0
<a name="l00175"></a>00175         self.assertEqual(t,abs(self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a>)**2.0)
<a name="l00176"></a>00176         t=abs(self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#aac73afdc7768f9a884c55c7d1c5559f1">c</a>)
<a name="l00177"></a>00177         self.assertEqual(t,5.0)
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ab372ec12affd4d96b604deaf93e280b3">00179</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ab372ec12affd4d96b604deaf93e280b3">testSimpleArithmetics</a>(self):
<a name="l00180"></a>00180         t = self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a>+self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a765656d62f787a28edb0ebfe8d99d8ff">y</a>
<a name="l00181"></a>00181         self.assertEqual(t,Vector([1,1,0]))
<a name="l00182"></a>00182         t -= self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a765656d62f787a28edb0ebfe8d99d8ff">y</a>
<a name="l00183"></a>00183         self.assertEqual(t,self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a>)
<a name="l00184"></a>00184         t = self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a> - self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a765656d62f787a28edb0ebfe8d99d8ff">y</a>
<a name="l00185"></a>00185         self.assertEqual(t,Vector([1,-1,0]))
<a name="l00186"></a>00186         t += self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a765656d62f787a28edb0ebfe8d99d8ff">y</a>
<a name="l00187"></a>00187         self.assertEqual(t,self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a>)
<a name="l00188"></a>00188         t = self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a> * 3.0
<a name="l00189"></a>00189         self.assertEqual(t,self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a>)
<a name="l00190"></a>00190         t /= 3.0
<a name="l00191"></a>00191         self.assertEqual(t,self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a>)
<a name="l00192"></a>00192         t = self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a> / 3.0
<a name="l00193"></a>00193         self.assertEqual(t,self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a>)
<a name="l00194"></a>00194         t *= 3.0
<a name="l00195"></a>00195         self.assertEqual(t,self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a>)
<a name="l00196"></a>00196         t = self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a> * self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a>
<a name="l00197"></a>00197         self.assertEqual(t,3.0)
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#aedc45061b0ead2c880c52ae0ac7a2469">00199</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#aedc45061b0ead2c880c52ae0ac7a2469">testOuter</a>(self):
<a name="l00200"></a>00200         t=self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a>.outer(self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a765656d62f787a28edb0ebfe8d99d8ff">y</a>)
<a name="l00201"></a>00201         self.assertEqual(t,self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#afffaaaf95e78ae1659732957885268a4">z</a>)
<a name="l00202"></a>00202 
<a name="l00203"></a><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a04e5dcb6644a694bcf6859c7bf13cb22">00203</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#a04e5dcb6644a694bcf6859c7bf13cb22">testNormalize</a>(self):
<a name="l00204"></a>00204         t=self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#af2c6308532591279b25325d21f14c878">a</a>.normalize()
<a name="l00205"></a>00205         self.assertEqual(t,self.<a class="code" href="classmagpar__scripts_1_1TestVectorClass.html#ae8eee6114b309781030a26186a2f51f8">x</a>)
<a name="l00206"></a>00206 
<a name="l00207"></a><a class="code" href="namespacemagpar__scripts.html#aa6c2446790d2a3246c978b424e95ff2f">00207</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#aa6c2446790d2a3246c978b424e95ff2f">initialize_magnetization_mx</a>(r):
<a name="l00208"></a>00208     <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00209"></a>00209 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00210"></a>00210     <span class="keywordflow">return</span> Vector([1.0, 0.0, 0.0])
<a name="l00211"></a>00211 
<a name="l00212"></a><a class="code" href="namespacemagpar__scripts.html#a4e3f9a1d603184f9ff136e46d26598e9">00212</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a4e3f9a1d603184f9ff136e46d26598e9">initialize_magnetization_my</a>(r):
<a name="l00213"></a>00213     <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00214"></a>00214 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00215"></a>00215     <span class="keywordflow">return</span> Vector([0.0, 1.0, 0.0])
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="namespacemagpar__scripts.html#a9f9dc713515bf6c1a96df980e343da19">00217</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a9f9dc713515bf6c1a96df980e343da19">initialize_magnetization_mz</a>(r):
<a name="l00218"></a>00218     <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00219"></a>00219 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00220"></a>00220     <span class="keywordflow">return</span> Vector([0.0, 0.0, 1.0])
<a name="l00221"></a>00221 
<a name="l00222"></a><a class="code" href="namespacemagpar__scripts.html#a2b4ce44119d522c3eb7f5161aa80966c">00222</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a2b4ce44119d522c3eb7f5161aa80966c">initialize_magnetization_111</a>(r):
<a name="l00223"></a>00223     <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00224"></a>00224 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00225"></a>00225     a=math.sqrt(1.0/3.0)
<a name="l00226"></a>00226     <span class="keywordflow">return</span> Vector([a, a, a])
<a name="l00227"></a>00227 
<a name="l00228"></a><a class="code" href="namespacemagpar__scripts.html#a54dedbc6e382fb7d003d37a63ff94115">00228</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a54dedbc6e382fb7d003d37a63ff94115">initialize_magnetization_theta_rad</a>(r, theta = 0):
<a name="l00229"></a>00229     <span class="stringliteral">&quot;&quot;&quot;Set magnetization in x-z plane to desired angle theta (from z-axis)</span>
<a name="l00230"></a>00230 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     <span class="keywordflow">return</span> Vector([math.sin(theta), 0.0, math.cos(theta)])
<a name="l00233"></a>00233 
<a name="l00234"></a><a class="code" href="namespacemagpar__scripts.html#a273ab57aa9481ae61e59b240b24c8e03">00234</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a273ab57aa9481ae61e59b240b24c8e03">initialize_magnetization_theta_deg</a>(r, theta_deg = 0):
<a name="l00235"></a>00235     m = initialize_magnetization_theta_rad(r,math.radians(theta_deg))
<a name="l00236"></a>00236 
<a name="l00237"></a>00237     <span class="keywordflow">return</span> m
<a name="l00238"></a>00238 
<a name="l00239"></a><a class="code" href="namespacemagpar__scripts.html#a5cdd1eae379f26c9720c49dec83d012d">00239</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a5cdd1eae379f26c9720c49dec83d012d">initialize_magnetization_phi_rad</a>(r, phi = 0):
<a name="l00240"></a>00240     <span class="stringliteral">&quot;&quot;&quot;Set magnetization in x-y plane to desired angle</span>
<a name="l00241"></a>00241 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00242"></a>00242 
<a name="l00243"></a>00243     <span class="keywordflow">return</span> Vector([math.cos(theta), math.sin(theta), 0.0])
<a name="l00244"></a>00244 
<a name="l00245"></a><a class="code" href="namespacemagpar__scripts.html#a85c04402596d19d113d048880d0b49e9">00245</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a85c04402596d19d113d048880d0b49e9">initialize_magnetization_phi_deg</a>(r,phi_deg = 0):
<a name="l00246"></a>00246     m = initialize_magnetization_phi_rad(r,math.radians(phi_deg))
<a name="l00247"></a>00247 
<a name="l00248"></a>00248     <span class="keywordflow">return</span> m
<a name="l00249"></a>00249 
<a name="l00250"></a><a class="code" href="namespacemagpar__scripts.html#af4f8c8f2600255797109042d0aaced26">00250</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#af4f8c8f2600255797109042d0aaced26">initialize_magnetization_random</a>(r):
<a name="l00251"></a>00251     <span class="stringliteral">&quot;&quot;&quot;Random magnetization - inaccurate: not uniform on unit sphere!</span>
<a name="l00252"></a>00252 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00253"></a>00253 
<a name="l00254"></a>00254     mx = random.uniform(-1, 1)
<a name="l00255"></a>00255     my = random.uniform(-1, 1)
<a name="l00256"></a>00256     mz = random.uniform(-1, 1)
<a name="l00257"></a>00257 
<a name="l00258"></a>00258     <span class="keywordflow">return</span> Vector([mx, my, mz])
<a name="l00259"></a>00259 
<a name="l00260"></a><a class="code" href="namespacemagpar__scripts.html#afce9532d1437fcbe8bca5ae719dc9860">00260</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#afce9532d1437fcbe8bca5ae719dc9860">initialize_magnetization_flower</a>(r, c = Vector([0.0,0.0,0.0]), f = 1.0):
<a name="l00261"></a>00261     <span class="stringliteral">&quot;&quot;&quot;Approximate flower state (around z-axis)</span>
<a name="l00262"></a>00262 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00263"></a>00263 
<a name="l00264"></a>00264     m = Vector([r[0]-c[0],r[1]-c[1],1.0])
<a name="l00265"></a>00265     <span class="keywordflow">if</span> (r[2]&lt;0):
<a name="l00266"></a>00266         m *= -1.0
<a name="l00267"></a>00267 
<a name="l00268"></a>00268     <span class="keywordflow">return</span> m
<a name="l00269"></a>00269 
<a name="l00270"></a><a class="code" href="namespacemagpar__scripts.html#a8a35f5cfdbb621da73fe2958051e1172">00270</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a8a35f5cfdbb621da73fe2958051e1172">vortex</a>(p, R):
<a name="l00271"></a>00271     <span class="stringliteral">&quot;&quot;&quot;Approximate vortex state</span>
<a name="l00272"></a>00272 <span class="stringliteral"></span>
<a name="l00273"></a>00273 <span class="stringliteral">    vortex centered at (cx, cy) with radius R:</span>
<a name="l00274"></a>00274 <span class="stringliteral">    if R&gt;0, then vortex is counter-clockwise in xy plane.</span>
<a name="l00275"></a>00275 <span class="stringliteral">    if R&lt;0, then vortex is clockwise in xy plane.</span>
<a name="l00276"></a>00276 <span class="stringliteral">    center of vortex points in pol*z direction.</span>
<a name="l00277"></a>00277 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00278"></a>00278 
<a name="l00279"></a>00279     r=p.copy()
<a name="l00280"></a>00280     r[2]=0
<a name="l00281"></a>00281     absr=abs(r)
<a name="l00282"></a>00282 
<a name="l00283"></a>00283     <span class="comment"># inside vortex core</span>
<a name="l00284"></a>00284     <span class="keywordflow">if</span> absr &lt;= math.fabs(R):
<a name="l00285"></a>00285         A = 2.0*R*absr/(R*R+absr*absr)
<a name="l00286"></a>00286         <span class="comment"># avoid division by zero</span>
<a name="l00287"></a>00287         <span class="keywordflow">if</span> (absr &gt; 1e-8):
<a name="l00288"></a>00288             m = Vector([A*r[1]/absr, -A*r[0]/absr, pol*math.sqrt(1.0-A*A)])
<a name="l00289"></a>00289         <span class="keywordflow">else</span>:
<a name="l00290"></a>00290             m = Vector([0.0, 0.0, pol])
<a name="l00291"></a>00291     <span class="comment"># outside vortex core</span>
<a name="l00292"></a>00292     <span class="keywordflow">else</span>:
<a name="l00293"></a>00293         m = Vector([r[1]/absr, -r[0]/absr, 0.0])
<a name="l00294"></a>00294 
<a name="l00295"></a>00295     <span class="keywordflow">if</span> R&lt;0:
<a name="l00296"></a>00296         m[0]=-m[0]
<a name="l00297"></a>00297         m[1]=-m[1]
<a name="l00298"></a>00298 
<a name="l00299"></a>00299     <span class="keywordflow">return</span> m
<a name="l00300"></a>00300 
<a name="l00301"></a><a class="code" href="namespacemagpar__scripts.html#a93fd61ba10b8db75116747a4f4c72435">00301</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a93fd61ba10b8db75116747a4f4c72435">initialize_magnetization_vortex</a>(r, c = Vector([0.0,0.0,0.0])):
<a name="l00302"></a>00302     <span class="stringliteral">&quot;&quot;&quot;Approximate vortex state</span>
<a name="l00303"></a>00303 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00304"></a>00304 
<a name="l00305"></a>00305     <span class="comment"># vortex radius</span>
<a name="l00306"></a>00306     R = 0.1
<a name="l00307"></a>00307 
<a name="l00308"></a>00308     <span class="comment"># polarity (+1.0 or -1.0)</span>
<a name="l00309"></a>00309     pol = 1.0
<a name="l00310"></a>00310 
<a name="l00311"></a>00311     m = vortex(r-c, R)
<a name="l00312"></a>00312     m[2] *= pol
<a name="l00313"></a>00313 
<a name="l00314"></a>00314     <span class="keywordflow">return</span> Vector(m)
<a name="l00315"></a>00315 
<a name="l00316"></a><a class="code" href="namespacemagpar__scripts.html#a06006b1162487783c82d6fd5fca08ccc">00316</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a06006b1162487783c82d6fd5fca08ccc">initialize_magnetization_blochwall</a>(r, xpos = 0.0, width = 0.1):
<a name="l00317"></a>00317     <span class="stringliteral">&quot;&quot;&quot;Bloch wall (parallel to y-z plane)</span>
<a name="l00318"></a>00318 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00319"></a>00319 
<a name="l00320"></a>00320     <span class="keywordflow">if</span> (r[0] &lt; xpos-width/2.0):
<a name="l00321"></a>00321         m = Vector([0.0, 0.0, -1.0])
<a name="l00322"></a>00322     <span class="keywordflow">elif</span> (r[0] &gt; xpos+width/2.0):
<a name="l00323"></a>00323         m = Vector([0.0, 0.0, 1.0])
<a name="l00324"></a>00324     <span class="keywordflow">else</span>:
<a name="l00325"></a>00325         m = Vector([0.0,
<a name="l00326"></a>00326                     math.cos((r[0]-xpos)/(width/2.0)*(math.pi/2.0)),
<a name="l00327"></a>00327                     math.sin((r[0]-xpos)/(width/2.0)*(math.pi/2.0))])
<a name="l00328"></a>00328 
<a name="l00329"></a>00329     <span class="keywordflow">return</span> m
<a name="l00330"></a>00330 
<a name="l00331"></a><a class="code" href="namespacemagpar__scripts.html#a13a5d8863f1e50544998dcef58cebb77">00331</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a13a5d8863f1e50544998dcef58cebb77">initialize_magnetization_head_to_head_transverse</a>(x, y, z, xpos = 0.0, width = 0.1):
<a name="l00332"></a>00332     <span class="stringliteral">&quot;&quot;&quot;Transverse head-to-head wall</span>
<a name="l00333"></a>00333 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00334"></a>00334 
<a name="l00335"></a>00335     <span class="keywordflow">if</span> (r[0] &lt; xpos-width/2.0):
<a name="l00336"></a>00336         m = Vector([1.0, 0.0, 0.0])
<a name="l00337"></a>00337     <span class="keywordflow">elif</span> (r[0] &gt; xpos+width/2.0):
<a name="l00338"></a>00338         m = Vector([-1.0, 0.0, 0.0])
<a name="l00339"></a>00339     <span class="keywordflow">else</span>:
<a name="l00340"></a>00340         m = Vector([-math.sin((x-xpos)/(width/2.0)*(math.pi/2.0)),
<a name="l00341"></a>00341                     math.cos((x-xpos)/(width/2.0)*(math.pi/2.0)),
<a name="l00342"></a>00342                     0.0])
<a name="l00343"></a>00343 
<a name="l00344"></a>00344     <span class="keywordflow">return</span> m
<a name="l00345"></a>00345 
<a name="l00346"></a><a class="code" href="namespacemagpar__scripts.html#a08d423bc675643daeeb49ec057efe98f">00346</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a08d423bc675643daeeb49ec057efe98f">initialize_magnetization_head_to_head_vortex</a>(r, xpos = 0.0, width = 0.1):
<a name="l00347"></a>00347     <span class="stringliteral">&quot;&quot;&quot;Approximate vortex head-to-head wall</span>
<a name="l00348"></a>00348 <span class="stringliteral"></span>
<a name="l00349"></a>00349 <span class="stringliteral">    Head-to-head vortex wall at (0, 0) with radius R</span>
<a name="l00350"></a>00350 <span class="stringliteral">    if R&gt;0, then vortex is clockwise in xy plane.</span>
<a name="l00351"></a>00351 <span class="stringliteral">    if R&lt;0, then vortex is counter-clockwise in xy plane.</span>
<a name="l00352"></a>00352 <span class="stringliteral">    center of vortex points in -z direction.</span>
<a name="l00353"></a>00353 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00354"></a>00354 
<a name="l00355"></a>00355     <span class="keywordflow">if</span> (x &lt; xpos-width/2.0):
<a name="l00356"></a>00356         m = Vector([1.0, 0.0, 0.0])
<a name="l00357"></a>00357     <span class="keywordflow">elif</span> (x &gt; xpos+width/2.0):
<a name="l00358"></a>00358         m = Vector([-1.0, 0.0, 0.0])
<a name="l00359"></a>00359     <span class="keywordflow">else</span>:
<a name="l00360"></a>00360         m = vortex(r-c, R)
<a name="l00361"></a>00361         m[2] *= pol
<a name="l00362"></a>00362 
<a name="l00363"></a>00363     <span class="keywordflow">return</span> m
<a name="l00364"></a>00364 
<a name="l00365"></a><a class="code" href="namespacemagpar__scripts.html#a2f04a438f7720f937e54b26735f5a27f">00365</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a2f04a438f7720f937e54b26735f5a27f">external_field_homogeneous</a>(r, theta_deg = 0.0, phi_deg = 0.0, amp_T = 0.0):
<a name="l00366"></a>00366     <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00367"></a>00367 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00368"></a>00368 
<a name="l00369"></a>00369     theta = math.radians(theta_deg)
<a name="l00370"></a>00370     phi   = math.radians(phi_deg)
<a name="l00371"></a>00371 
<a name="l00372"></a>00372     h = Vector([amp_T*math.sin(theta)*math.cos(phi),
<a name="l00373"></a>00373                 amp_T*math.sin(theta)*math.sin(phi),
<a name="l00374"></a>00374                 amp_T*math.cos(theta)])
<a name="l00375"></a>00375 
<a name="l00376"></a>00376     <span class="keywordflow">return</span> h
<a name="l00377"></a>00377 
<a name="l00378"></a><a class="code" href="namespacemagpar__scripts.html#afe500c0fa5ce5db6b713d879d674236f">00378</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#afe500c0fa5ce5db6b713d879d674236f">external_field_time_scaling</a>(t_ns):
<a name="l00379"></a>00379     <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00380"></a>00380 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00381"></a>00381 
<a name="l00382"></a>00382     <span class="keywordflow">if</span> (t_ns&lt;0):
<a name="l00383"></a>00383         amp_T=0
<a name="l00384"></a>00384     <span class="keywordflow">else</span>:
<a name="l00385"></a>00385         amp_T=t_ns
<a name="l00386"></a>00386 
<a name="l00387"></a>00387     <span class="keywordflow">return</span> amp_T
<a name="l00388"></a>00388 
<a name="l00389"></a><a class="code" href="classmagpar__scripts_1_1Line.html">00389</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1Line.html">Line</a>:
<a name="l00390"></a><a class="code" href="classmagpar__scripts_1_1Line.html#aee365b1f50bd58be0074c1519aef40e0">00390</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Line.html#aee365b1f50bd58be0074c1519aef40e0">__init__</a>(self,a,b):
<a name="l00391"></a><a class="code" href="classmagpar__scripts_1_1Line.html#ae7605b30b07008011682d11203a76fa8">00391</a>       self.<a class="code" href="classmagpar__scripts_1_1Line.html#ae7605b30b07008011682d11203a76fa8">start_point</a> = a
<a name="l00392"></a><a class="code" href="classmagpar__scripts_1_1Line.html#a8aae8fd5997850256c3cfda7f9c42cf6">00392</a>       self.<a class="code" href="classmagpar__scripts_1_1Line.html#a8aae8fd5997850256c3cfda7f9c42cf6">end_point</a> = b
<a name="l00393"></a><a class="code" href="classmagpar__scripts_1_1Line.html#a8801a9522b5d55c0c14d4b75c1dbd343">00393</a>       self.<a class="code" href="classmagpar__scripts_1_1Line.html#a8801a9522b5d55c0c14d4b75c1dbd343">vector</a> = b-a
<a name="l00394"></a><a class="code" href="classmagpar__scripts_1_1Line.html#a0e528c00e7bff9220918fe2741a0dbd5">00394</a>       self.<a class="code" href="classmagpar__scripts_1_1Line.html#a0e528c00e7bff9220918fe2741a0dbd5">length</a> = abs(b-a)
<a name="l00395"></a>00395 
<a name="l00396"></a><a class="code" href="classmagpar__scripts_1_1Line.html#a5f448ed701dd3b169464ef18f4f4bf6a">00396</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Line.html#a5f448ed701dd3b169464ef18f4f4bf6a">__str__</a>(self):
<a name="l00397"></a>00397         <span class="keywordflow">return</span> <span class="stringliteral">&quot;start_point: &quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Line.html#ae7605b30b07008011682d11203a76fa8">start_point</a>) + <span class="stringliteral">&quot;\n&quot;</span> + \
<a name="l00398"></a>00398                <span class="stringliteral">&quot;end_point:   &quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Line.html#a8aae8fd5997850256c3cfda7f9c42cf6">end_point</a>) + <span class="stringliteral">&quot;\n&quot;</span>  + \
<a name="l00399"></a>00399                <span class="stringliteral">&quot;vector:      &quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Line.html#a8801a9522b5d55c0c14d4b75c1dbd343">vector</a>) + <span class="stringliteral">&quot;\n&quot;</span>  + \
<a name="l00400"></a>00400                <span class="stringliteral">&quot;length:      &quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Line.html#a0e528c00e7bff9220918fe2741a0dbd5">length</a>) + <span class="stringliteral">&quot;\n&quot;</span>
<a name="l00401"></a>00401 
<a name="l00402"></a><a class="code" href="classmagpar__scripts_1_1TestLineClass.html">00402</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1TestLineClass.html">TestLineClass</a>(unittest.TestCase):
<a name="l00403"></a><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a56f6cef08404751bcbfe8055b711657a">00403</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a56f6cef08404751bcbfe8055b711657a">setUp</a>(self):
<a name="l00404"></a><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a5fbe7e30d0cd7f527a55bde8038b00f8">00404</a>         self.<a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a5fbe7e30d0cd7f527a55bde8038b00f8">a</a>=Vector([3,0,0])
<a name="l00405"></a><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a3e6234794a65903b611baf89f9a71088">00405</a>         self.<a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a3e6234794a65903b611baf89f9a71088">b</a>=Vector([0,4,0])
<a name="l00406"></a><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a63efe58a4c4065857b37a234870d2661">00406</a>         self.<a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a63efe58a4c4065857b37a234870d2661">line</a>=Line(self.<a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a5fbe7e30d0cd7f527a55bde8038b00f8">a</a>,self.<a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a3e6234794a65903b611baf89f9a71088">b</a>)
<a name="l00407"></a>00407 
<a name="l00408"></a><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#ac344706109083060f339bdc0aa51bd7c">00408</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#ac344706109083060f339bdc0aa51bd7c">testvector</a>(self):
<a name="l00409"></a>00409         self.assertEqual(self.<a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a63efe58a4c4065857b37a234870d2661">line</a>.vector,Vector([-3,4,0]))
<a name="l00410"></a>00410 
<a name="l00411"></a><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a1cf411059387761f2bc8235cabd89704">00411</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a1cf411059387761f2bc8235cabd89704">testlength</a>(self):
<a name="l00412"></a>00412         self.assertEqual(self.<a class="code" href="classmagpar__scripts_1_1TestLineClass.html#a63efe58a4c4065857b37a234870d2661">line</a>.length,5)
<a name="l00413"></a>00413 
<a name="l00414"></a><a class="code" href="classmagpar__scripts_1_1Segment.html">00414</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1Segment.html">Segment</a>:
<a name="l00415"></a><a class="code" href="classmagpar__scripts_1_1Segment.html#aee16a013254c3986a1b1b9a706e3bf7a">00415</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Segment.html#aee16a013254c3986a1b1b9a706e3bf7a">__init__</a>(self,s,a,b):
<a name="l00416"></a><a class="code" href="classmagpar__scripts_1_1Segment.html#ade4c7e2bce9dc6da07ecd8c652145c09">00416</a>       self.<a class="code" href="classmagpar__scripts_1_1Segment.html#ade4c7e2bce9dc6da07ecd8c652145c09">start</a> = s
<a name="l00417"></a><a class="code" href="classmagpar__scripts_1_1Segment.html#ad15f47f93f8d53b0c24ccaaccfbaed06">00417</a>       self.<a class="code" href="classmagpar__scripts_1_1Segment.html#ad15f47f93f8d53b0c24ccaaccfbaed06">line</a> = Line(a,b)
<a name="l00418"></a>00418 
<a name="l00419"></a><a class="code" href="classmagpar__scripts_1_1Segment.html#aab2c4576631b455a395e46105aca5935">00419</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Segment.html#aab2c4576631b455a395e46105aca5935">__str__</a>(self):
<a name="l00420"></a>00420         <span class="keywordflow">return</span> <span class="stringliteral">&quot;start: &quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Segment.html#ade4c7e2bce9dc6da07ecd8c652145c09">start</a>) + <span class="stringliteral">&quot;\n&quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Segment.html#ad15f47f93f8d53b0c24ccaaccfbaed06">line</a>)
<a name="l00421"></a>00421 
<a name="l00422"></a><a class="code" href="classmagpar__scripts_1_1Polygon.html">00422</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1Polygon.html">Polygon</a>:
<a name="l00423"></a><a class="code" href="classmagpar__scripts_1_1Polygon.html#a4d9403b32b643bacc75c427120ef6e7e">00423</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Polygon.html#a4d9403b32b643bacc75c427120ef6e7e">__init__</a>(self):
<a name="l00424"></a><a class="code" href="classmagpar__scripts_1_1Polygon.html#a8de47cfb30a18cdd9d429670985308f9">00424</a>         self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8de47cfb30a18cdd9d429670985308f9">segments</a> = []
<a name="l00425"></a><a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">00425</a>         self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a> = 0.0
<a name="l00426"></a>00426 
<a name="l00427"></a><a class="code" href="classmagpar__scripts_1_1Polygon.html#a9c9b2da659a2026b33343f883b1df8df">00427</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Polygon.html#a9c9b2da659a2026b33343f883b1df8df">append_segment</a>(self,a,b):
<a name="l00428"></a>00428         self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8de47cfb30a18cdd9d429670985308f9">segments</a>.append(Segment(self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a>,a,b))
<a name="l00429"></a>00429         self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a> += abs(b-a)
<a name="l00430"></a>00430 
<a name="l00431"></a><a class="code" href="classmagpar__scripts_1_1Polygon.html#ab70b184783715a102a9a696ea7405406">00431</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Polygon.html#ab70b184783715a102a9a696ea7405406">point</a>(self,u):
<a name="l00432"></a>00432         <span class="keywordflow">for</span> s <span class="keywordflow">in</span> self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8de47cfb30a18cdd9d429670985308f9">segments</a>:
<a name="l00433"></a>00433             <span class="keywordflow">if</span> (u&gt;=s.start/self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a>) &amp; (u&lt;(s.start+s.line.length)/self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a>):
<a name="l00434"></a>00434                 p = s.line.start_point + (u-s.start/self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a>)*s.line.vector/s.line.length*self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a>
<a name="l00435"></a>00435                 <span class="keywordflow">return</span> p
<a name="l00436"></a>00436 
<a name="l00437"></a><a class="code" href="classmagpar__scripts_1_1Polygon.html#aa70ff6082a31fb51b183a2979a587c6a">00437</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Polygon.html#aa70ff6082a31fb51b183a2979a587c6a">vec</a>(self,u,length):
<a name="l00438"></a>00438         <span class="keywordflow">for</span> s <span class="keywordflow">in</span> self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8de47cfb30a18cdd9d429670985308f9">segments</a>:
<a name="l00439"></a>00439             <span class="keywordflow">if</span> (u&gt;=s.start/self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a>) &amp; (u&lt;(s.start+s.line.length)/self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a>):
<a name="l00440"></a>00440                 v = Vector(s.line.vector)
<a name="l00441"></a>00441                 v.normalize()
<a name="l00442"></a>00442                 <span class="keywordflow">return</span> v*length
<a name="l00443"></a>00443 
<a name="l00444"></a><a class="code" href="classmagpar__scripts_1_1Polygon.html#a12ffbe285dd623d8316edb42065a2d26">00444</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Polygon.html#a12ffbe285dd623d8316edb42065a2d26">__str__</a>(self):
<a name="l00445"></a>00445         string = <span class="stringliteral">&quot;Polygon of length &quot;</span> + str(self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8937ab795a2136dddb3c28d81885c4c1">length</a>) + \
<a name="l00446"></a>00446                  <span class="stringliteral">&quot; with &quot;</span> + str(len(self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8de47cfb30a18cdd9d429670985308f9">segments</a>)) + <span class="stringliteral">&quot; segments\n&quot;</span>
<a name="l00447"></a>00447         <span class="keywordflow">for</span> s <span class="keywordflow">in</span> self.<a class="code" href="classmagpar__scripts_1_1Polygon.html#a8de47cfb30a18cdd9d429670985308f9">segments</a>:
<a name="l00448"></a>00448             string += str(s)
<a name="l00449"></a>00449         <span class="keywordflow">return</span> string
<a name="l00450"></a>00450 
<a name="l00451"></a><a class="code" href="namespacemagpar__scripts.html#aa122a311e0946575a7075f09eebf67d4">00451</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#aa122a311e0946575a7075f09eebf67d4">test_straight_poly</a>():
<a name="l00452"></a>00452     poly_points=[]
<a name="l00453"></a>00453     poly_points.append(Vector([-100.0,0.0,0.0]))
<a name="l00454"></a>00454     poly_points.append(Vector([ -50.0,0.0,0.0]))
<a name="l00455"></a>00455     poly_points.append(Vector([ -10.0,0.0,0.0]))
<a name="l00456"></a>00456     poly_points.append(Vector([   0.0,0.0,0.0]))
<a name="l00457"></a>00457     poly_points.append(Vector([   5.0,0.0,0.0]))
<a name="l00458"></a>00458     poly_points.append(Vector([  30.0,0.0,0.0]))
<a name="l00459"></a>00459     poly_points.append(Vector([ 100.0,0.0,0.0]))
<a name="l00460"></a>00460     polygon = Polygon()
<a name="l00461"></a>00461     <span class="keywordflow">for</span> s <span class="keywordflow">in</span> range(len(poly_points)-1):
<a name="l00462"></a>00462         polygon.append_segment(poly_points[s],poly_points[s+1])
<a name="l00463"></a>00463     <span class="keywordflow">return</span> polygon
<a name="l00464"></a>00464 
<a name="l00465"></a><a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html">00465</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html">TestPolygonClass</a>(unittest.TestCase):
<a name="l00466"></a><a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#a753f6e5b7a529c5b2ca74559fe3e520b">00466</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#a753f6e5b7a529c5b2ca74559fe3e520b">setUp</a>(self):
<a name="l00467"></a><a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#ab63da05cb19bcd3bc2c6530bb488a5a0">00467</a>         self.<a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#ab63da05cb19bcd3bc2c6530bb488a5a0">polygon</a> = test_straight_poly()
<a name="l00468"></a>00468 
<a name="l00469"></a><a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#a88d914e42ec91140b42dab87c40560d8">00469</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#a88d914e42ec91140b42dab87c40560d8">testpoints</a>(self):
<a name="l00470"></a>00470         self.assertEqual(self.<a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#ab63da05cb19bcd3bc2c6530bb488a5a0">polygon</a>.point(0),self.<a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#ab63da05cb19bcd3bc2c6530bb488a5a0">polygon</a>.segments[0].line.start_point)
<a name="l00471"></a>00471         self.assertEqual(self.<a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#ab63da05cb19bcd3bc2c6530bb488a5a0">polygon</a>.length,200)
<a name="l00472"></a>00472         self.assertEqual(self.<a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#ab63da05cb19bcd3bc2c6530bb488a5a0">polygon</a>.point(0.5),Vector([0,0,0]))
<a name="l00473"></a>00473         self.assertEqual(self.<a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#ab63da05cb19bcd3bc2c6530bb488a5a0">polygon</a>.point(0.99),Vector([98,0,0]))
<a name="l00474"></a>00474         self.assertEqual(self.<a class="code" href="classmagpar__scripts_1_1TestPolygonClass.html#ab63da05cb19bcd3bc2c6530bb488a5a0">polygon</a>.vec(0,1),Vector([1,0,0]))
<a name="l00475"></a>00475 
<a name="l00476"></a><a class="code" href="namespacemagpar__scripts.html#a1eb54de263be89953a71f0d2a57727d1">00476</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a1eb54de263be89953a71f0d2a57727d1">biot_savart</a>(current_A, r, ds):
<a name="l00477"></a>00477     <span class="stringliteral">&quot;&quot;&quot;Calculate magnetic field according to Biot-Savart law</span>
<a name="l00478"></a>00478 <span class="stringliteral"></span>
<a name="l00479"></a>00479 <span class="stringliteral">    dB=mu0*I/(4 pi)* (ds x r)/r^3</span>
<a name="l00480"></a>00480 <span class="stringliteral"></span>
<a name="l00481"></a>00481 <span class="stringliteral">    http://en.wikipedia.org/wiki/Biot-Savart_law</span>
<a name="l00482"></a>00482 <span class="stringliteral">    http://maxwell.byu.edu/~spencerr/websumm122/node70.html</span>
<a name="l00483"></a>00483 <span class="stringliteral">    http://hyperphysics.phy-astr.gsu.edu/HBASE/magnetic/magcur.html#c2</span>
<a name="l00484"></a>00484 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 <span class="comment">#    if abs(r) &lt; abs(ds)*5.0:</span>
<a name="l00487"></a>00487 <span class="comment">#        print &quot;Warning: distance r &quot;, abs(r), r, &quot; too short compared to segment ds &quot;, abs(ds), ds</span>
<a name="l00488"></a>00488 
<a name="l00489"></a>00489     <span class="keywordflow">if</span> abs(r)&lt;1e-9:
<a name="l00490"></a>00490         <span class="comment"># catch 1/r divergence</span>
<a name="l00491"></a>00491         h = Vector([0,0,0])
<a name="l00492"></a>00492     <span class="keywordflow">else</span>:
<a name="l00493"></a>00493         h = 1e-7*current_A*ds.outer(r)/abs(r)**3.0
<a name="l00494"></a>00494     <span class="keywordflow">return</span> h
<a name="l00495"></a>00495 
<a name="l00496"></a><a class="code" href="classmagpar__scripts_1_1TestBiotSavart.html">00496</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1TestBiotSavart.html">TestBiotSavart</a>(unittest.TestCase):
<a name="l00497"></a><a class="code" href="classmagpar__scripts_1_1TestBiotSavart.html#aa7b94d6aba705ad6b7935963b9da3b9f">00497</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestBiotSavart.html#aa7b94d6aba705ad6b7935963b9da3b9f">setUp</a>(self):
<a name="l00498"></a><a class="code" href="classmagpar__scripts_1_1TestBiotSavart.html#a6e053c9d762969097593ac1293a9e34e">00498</a>         self.<a class="code" href="classmagpar__scripts_1_1TestBiotSavart.html#a6e053c9d762969097593ac1293a9e34e">polygon</a> = test_straight_poly()
<a name="l00499"></a>00499 
<a name="l00500"></a><a class="code" href="classmagpar__scripts_1_1TestBiotSavart.html#ac2b1276b2f1cfd375434491c0ee2576a">00500</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1TestBiotSavart.html#ac2b1276b2f1cfd375434491c0ee2576a">testfield</a>(self):
<a name="l00501"></a>00501         h=biot_savart(1.0, Vector([0,0,1]), Vector([0.01,0,0]))
<a name="l00502"></a>00502         self.assertAlmostEqual(abs(h)*1e9,1,5)
<a name="l00503"></a>00503         h.normalize()
<a name="l00504"></a>00504         self.assertEqual(h,Vector([0,-1,0]))
<a name="l00505"></a>00505 
<a name="l00506"></a><a class="code" href="namespacemagpar__scripts.html#a8486bf09c2c0387de3cb167c33ea95e3">00506</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a8486bf09c2c0387de3cb167c33ea95e3">field_of_wire_slow</a>(wire,current_A,r):
<a name="l00507"></a>00507     npoints=10000
<a name="l00508"></a>00508     h = Vector()
<a name="l00509"></a>00509     <span class="keywordflow">for</span> u <span class="keywordflow">in</span> range(0,npoints):
<a name="l00510"></a>00510         <span class="comment">#print wire.point(u*1.0/npoints), wire.vec(u*1.0/npoints,wire.length/npoints), r</span>
<a name="l00511"></a>00511         h += biot_savart(current_A, \
<a name="l00512"></a>00512                     wire.point(u*1.0/npoints)-r, \
<a name="l00513"></a>00513                     wire.vec(u*1.0/npoints,wire.length/npoints))
<a name="l00514"></a>00514     <span class="keywordflow">return</span> h
<a name="l00515"></a>00515 
<a name="l00516"></a><a class="code" href="namespacemagpar__scripts.html#a8b2a12e6a0a5e451cd66a8ee0ccde750">00516</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a8b2a12e6a0a5e451cd66a8ee0ccde750">field_of_wire</a>(wire,current_A,r):
<a name="l00517"></a>00517     npoints=1000
<a name="l00518"></a>00518     h = Vector()
<a name="l00519"></a>00519     <span class="keywordflow">for</span> s <span class="keywordflow">in</span> wire.segments:
<a name="l00520"></a>00520         <span class="keywordflow">for</span> u <span class="keywordflow">in</span> range(0,npoints):
<a name="l00521"></a>00521             h += biot_savart(current_A, \
<a name="l00522"></a>00522                         s.line.start_point+s.line.vector*u/npoints-r, \
<a name="l00523"></a>00523                         s.line.vector/npoints)
<a name="l00524"></a>00524     <span class="keywordflow">return</span> h
<a name="l00525"></a>00525 
<a name="l00526"></a><a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html">00526</a> <span class="keyword">class </span><a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html">Test_external_field_wire</a>(unittest.TestCase):
<a name="l00527"></a><a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html#a1b69016f6a4e10e3aeb402c45e50f72b">00527</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html#a1b69016f6a4e10e3aeb402c45e50f72b">setUp</a>(self):
<a name="l00528"></a><a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html#a9e7ae0439b03f649bcec45dcfa009bd3">00528</a>         self.<a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html#a9e7ae0439b03f649bcec45dcfa009bd3">polygon</a> = test_straight_poly()
<a name="l00529"></a>00529 
<a name="l00530"></a>00530     <span class="comment"># http://hyperphysics.phy-astr.gsu.edu/HBASE/magnetic/magcur.html#c2</span>
<a name="l00531"></a><a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html#a66cb7b9eeb26d56a9d004deff5b13c75">00531</a>     <span class="keyword">def </span><a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html#a66cb7b9eeb26d56a9d004deff5b13c75">testfield</a>(self):
<a name="l00532"></a>00532         h = field_of_wire_slow(self.<a class="code" href="classmagpar__scripts_1_1Test__external__field__wire.html#a9e7ae0439b03f649bcec45dcfa009bd3">polygon</a>,1.0,Vector([0,0,0.1]))
<a name="l00533"></a>00533 
<a name="l00534"></a>00534         self.assertAlmostEqual(abs(h)*1e7,20,4)
<a name="l00535"></a>00535         h.normalize()
<a name="l00536"></a>00536         self.assertEqual(h,Vector([0,1,0]))
<a name="l00537"></a>00537 
<a name="l00538"></a><a class="code" href="namespacemagpar__scripts.html#af64bef2d33cf392cfaf3e0d2fdfaedf3">00538</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#af64bef2d33cf392cfaf3e0d2fdfaedf3">initmag</a>(x, y, z):
<a name="l00539"></a>00539     <span class="stringliteral">&quot;&quot;&quot;Initialize magnetization with desired function called in here.</span>
<a name="l00540"></a>00540 <span class="stringliteral"></span>
<a name="l00541"></a>00541 <span class="stringliteral">    This function must be define after all the initialize_magnetization_* functions!</span>
<a name="l00542"></a>00542 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00543"></a>00543 
<a name="l00544"></a>00544     r = Vector([x,y,z])
<a name="l00545"></a>00545     m = initialize_magnetization_mx(r)
<a name="l00546"></a>00546 
<a name="l00547"></a>00547     m /= abs(m)
<a name="l00548"></a>00548 
<a name="l00549"></a>00549     <span class="keywordflow">return</span> m[0],m[1],m[2]
<a name="l00550"></a>00550 
<a name="l00551"></a><a class="code" href="namespacemagpar__scripts.html#a4889fc687075408e47586441d78bc2bc">00551</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a4889fc687075408e47586441d78bc2bc">hext_xyz2</a>(x, y, z):
<a name="l00552"></a>00552     <span class="stringliteral">&quot;&quot;&quot;Set external field with desired function called in here.</span>
<a name="l00553"></a>00553 <span class="stringliteral"></span>
<a name="l00554"></a>00554 <span class="stringliteral">    This function must be define after all the external_field_* functions!</span>
<a name="l00555"></a>00555 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00556"></a>00556 
<a name="l00557"></a>00557     h_T = external_field_homogeneous(x, y, z)
<a name="l00558"></a>00558 
<a name="l00559"></a>00559     <span class="keywordflow">return</span> h_T[0], h_T[1], h_T[2]
<a name="l00560"></a>00560 
<a name="l00561"></a><a class="code" href="namespacemagpar__scripts.html#aeeee98d34a6b07b9887f1f17f32e4cfb">00561</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#aeeee98d34a6b07b9887f1f17f32e4cfb">hext_xyzt</a>(x, y, z, t_ns):
<a name="l00562"></a>00562     <span class="stringliteral">&quot;&quot;&quot;Set external field with desired function called in here.</span>
<a name="l00563"></a>00563 <span class="stringliteral"></span>
<a name="l00564"></a>00564 <span class="stringliteral">    This function must be define after all the external_field_* functions!</span>
<a name="l00565"></a>00565 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00566"></a>00566 
<a name="l00567"></a>00567     h_T = external_field_homogeneous(x, y, z)
<a name="l00568"></a>00568     f = external_field_time_scaling(t_ns)
<a name="l00569"></a>00569 
<a name="l00570"></a>00570     <span class="keywordflow">return</span> h_T[0]*f, h_T[1]*f, h_T[2]*f
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 <span class="comment"># Finally, import user defined functions.</span>
<a name="l00573"></a>00573 <span class="comment"># These can shadow/overload the standard functions above!</span>
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 <span class="comment">#from magpar_user_scripts import *</span>
<a name="l00576"></a>00576 
<a name="l00577"></a>00577 <span class="comment"># from: http://www.python.org/doc/essays/list2str.html</span>
<a name="l00578"></a>00578 <span class="keyword">import</span> time
<a name="l00579"></a><a class="code" href="namespacemagpar__scripts.html#a9a780374934c6a43567623106e9bd930">00579</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a9a780374934c6a43567623106e9bd930">timing</a>(f, n, a):
<a name="l00580"></a>00580     <span class="keywordflow">print</span> f.__name__,
<a name="l00581"></a>00581     r = range(n)
<a name="l00582"></a>00582     t1 = time.clock()
<a name="l00583"></a>00583     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> r:
<a name="l00584"></a>00584         f(a); f(a); f(a); f(a); f(a); f(a); f(a); f(a); f(a); f(a)
<a name="l00585"></a>00585     t2 = time.clock()
<a name="l00586"></a>00586     <span class="keywordflow">print</span> round(t2-t1, 3)
<a name="l00587"></a>00587 
<a name="l00588"></a><a class="code" href="namespacemagpar__scripts.html#ab313689e503e5184361832ec84f8bb9e">00588</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#ab313689e503e5184361832ec84f8bb9e">test_function_2col</a>():
<a name="l00589"></a>00589     astart = -3.0
<a name="l00590"></a>00590     astop = 3.0
<a name="l00591"></a>00591     nstep = 100
<a name="l00592"></a>00592 
<a name="l00593"></a>00593     <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(nstep+1):
<a name="l00594"></a>00594         a = astart+i*(astop-astart)/nstep
<a name="l00595"></a>00595 
<a name="l00596"></a>00596         <span class="comment"># v1, v2, v3 = initialize_magnetization_flower(a, 0, 0)</span>
<a name="l00597"></a>00597         v1 = hext_xyzt(0,0,0,a)
<a name="l00598"></a>00598 
<a name="l00599"></a>00599         <span class="keywordflow">print</span> a, v1
<a name="l00600"></a>00600 
<a name="l00601"></a><a class="code" href="namespacemagpar__scripts.html#a73c362a0a7f24f6d51c3f0160e784e46">00601</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a73c362a0a7f24f6d51c3f0160e784e46">misc3</a>():
<a name="l00602"></a>00602     <span class="keyword">import</span> matplotlib.pyplot <span class="keyword">as</span> plt
<a name="l00603"></a>00603     plt.plotfile(<span class="stringliteral">&quot;x&quot;</span>,cols=(0,1),delimiter=<span class="stringliteral">&quot; &quot;</span>)
<a name="l00604"></a>00604 
<a name="l00605"></a><a class="code" href="namespacemagpar__scripts.html#a59d1a14482e403787445cdd72729eb36">00605</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a59d1a14482e403787445cdd72729eb36">wire_z</a>():
<a name="l00606"></a>00606     poly_points=[]
<a name="l00607"></a>00607     poly_points.append(Vector([0.0,0.0, -10.0]))
<a name="l00608"></a>00608     poly_points.append(Vector([0.0,0.0,  10.0]))
<a name="l00609"></a>00609     polygon = Polygon()
<a name="l00610"></a>00610     <span class="keywordflow">for</span> s <span class="keywordflow">in</span> range(len(poly_points)-1):
<a name="l00611"></a>00611         polygon.append_segment(poly_points[s],poly_points[s+1])
<a name="l00612"></a>00612     <span class="keywordflow">return</span> polygon
<a name="l00613"></a>00613 
<a name="l00614"></a><a class="code" href="namespacemagpar__scripts.html#acec0f7080ab7b20ede1339ea10a5af09">00614</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#acec0f7080ab7b20ede1339ea10a5af09">hext_f</a>(t_ns):
<a name="l00615"></a>00615     <span class="stringliteral">&quot;&quot;&quot;</span>
<a name="l00616"></a>00616 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00617"></a>00617 
<a name="l00618"></a>00618     tstart = 0.0
<a name="l00619"></a>00619     fstart = 0.0
<a name="l00620"></a>00620     tend   = 50.0
<a name="l00621"></a>00621     fend   = 200.0
<a name="l00622"></a>00622 
<a name="l00623"></a>00623     <span class="keywordflow">if</span> t_ns &lt; t_start:
<a name="l00624"></a>00624         f=fstart
<a name="l00625"></a>00625     <span class="keywordflow">elif</span> t_ns &lt; fend:
<a name="l00626"></a>00626         f=fstart+(fend-fstart)*(t_ns-tstart)/(tend-tstart)
<a name="l00627"></a>00627 
<a name="l00628"></a>00628     <span class="keywordflow">return</span> f
<a name="l00629"></a>00629 
<a name="l00630"></a><a class="code" href="namespacemagpar__scripts.html#a40a8f3ca93e972521b5a7c8ed44eb2d8">00630</a> coils = wire_z()
<a name="l00631"></a>00631 
<a name="l00632"></a><a class="code" href="namespacemagpar__scripts.html#a83afadbbc6cc100df4bbaa185748b0db">00632</a> <span class="keyword">def </span><a class="code" href="namespacemagpar__scripts.html#a83afadbbc6cc100df4bbaa185748b0db">hext_xyz</a>(x, y, z):
<a name="l00633"></a>00633     <span class="stringliteral">&quot;&quot;&quot;Set external field with desired function called in here.</span>
<a name="l00634"></a>00634 <span class="stringliteral"></span>
<a name="l00635"></a>00635 <span class="stringliteral">    This function must be defined after all the external_field_* functions!</span>
<a name="l00636"></a>00636 <span class="stringliteral">    &quot;&quot;&quot;</span>
<a name="l00637"></a>00637 
<a name="l00638"></a>00638     h_T = field_of_wire(coils,0.001,Vector([x,y,z]))
<a name="l00639"></a>00639 
<a name="l00640"></a>00640     <span class="keywordflow">return</span> h_T[0], h_T[1], h_T[2]
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 <span class="comment"># http://docs.python.org/tutorial/modules.html#executing-modules-as-scripts</span>
<a name="l00643"></a>00643 <span class="keywordflow">if</span> __name__ == <span class="stringliteral">&quot;__main__&quot;</span>:
<a name="l00644"></a>00644     <span class="comment">#test_function_2col()</span>
<a name="l00645"></a>00645 
<a name="l00646"></a>00646     <span class="comment">#print hext_xyz(1.0,0,0)</span>
<a name="l00647"></a>00647     cProfile.run(<span class="stringliteral">&#39;print hext_xyz(1.0,0,0)&#39;</span>)
<a name="l00648"></a>00648 
<a name="l00649"></a>00649     unittest.main()
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

